unit Unit1;
{ Exemple de dessin de bitmap transparent
 (c)2001 Paul TOTH <tothpaul@free.fr>
 Extrait du tutorial "Point Virgule" sur http://tothpaul.free.fr/pv.php3
}
interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls;

type
  TForm1 = class(TForm)
    A: TImage;
    RadioGroup1: TRadioGroup;
    Fond: TImage;
    Image1: TImage;
    Image2: TImage;
    Image3: TImage;
    Image4: TImage;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    procedure RadioGroup1Click(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.RadioGroup1Click(Sender: TObject);
Const
 ROP_DSPDxax = $00E20746;
var
 src,dst:HDC;
 mono:HBitmap;
begin
 case RadioGroup1.ItemIndex of
  0 : begin  // cration d'un bitmap monochrome
             // noir sur l'image, blanc sur le fond
       Image1.Picture.Assign(A.Picture); // pour avoir un bitmap...

       src:=A.Picture.Bitmap.Canvas.Handle;
      //Create a monochrome bitmap for masking
       dst:=CreateCompatibleDC(src);
       Mono:=CreateBitmap(A.Width,A.Height,1,1,nil);
       SelectObject(dst,Mono);
       Image1.Picture.Bitmap.Canvas.Handle:=dst; // Image1 est maintenant un bitmap monochrome
      //Create a monochrome mask where we have 0's in the image, 1's elsewhere.

       SetBkColor(src,A.Picture.Bitmap.Canvas.Pixels[0,0]); // couleur de transparence
       BitBlt(dst, 0,0,A.Width,A.Height, src, 0,0,SRCCOPY); // copie vers monochrome

       Image2.Picture:=nil;
       Image3.Picture:=nil;
       Image4.Picture:=nil;
      end;
  1 : begin // dcoupe du masque monochrome sur l'image de fond
            // l'opration AND assure le dcoupage
       Image2.Picture.Assign(Fond.Picture);
      {
       Image2.Picture.Bitmap.Canvas.CopyMode:=cmSrcAnd;
       Image2.Picture.Bitmap.Canvas.Draw(0,0,Image1.Picture.Bitmap);
      }
       src:=Image1.Picture.Bitmap.Canvas.Handle;
       dst:=Image2.Picture.Bitmap.Canvas.Handle;
       BitBlt(dst, 0,0,A.Width,A.Height, src, 0, 0, SRCAND);

       Image3.Picture:=nil;
       Image4.Picture:=nil;
      end;
  2 : begin // prparation de l'image  la copie
            // il faut mettre en noir tous les pixels transparent (pour opration suivante)
       Image3.Picture.Assign(A.Picture);

       src:=Image1.Picture.Bitmap.Canvas.Handle;
       dst:=Image3.Picture.Bitmap.Canvas.Handle;
       SelectObject(dst,CreateSolidBrush(0));
       BitBlt(dst, 0,0,A.Width,A.Height, src, 0, 0, ROP_DSPDxax); // magic !

       Image4.Picture:=nil;
      end;
  3 : begin // remplissage du trou du masque par l'image prpare
            // l'opration OR laisse le "fond" inchang et rempli le trou
       Image4.Picture.Assign(Image2.Picture);
      {
       Image4.Picture.Bitmap.Canvas.CopyMode:=cmSrcPaint;
       Image4.Picture.Bitmap.Canvas.Draw(0,0,Image3.Picture.Bitmap);
      }
       src:=Image3.Picture.Bitmap.Canvas.Handle;
       dst:=Image4.Picture.Bitmap.Canvas.Handle;
       BitBlt(dst, 0,0,A.Width,A.Height, src, 0, 0, SRCPAINT);
      end;
 end;
end;

end.
